using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using BinaryTree;

namespace SearchTree
{
	
	public class SearchTree : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel headerPanel;
		private System.Windows.Forms.Label titleLabel;
		private System.Windows.Forms.Panel controlPanel;
		private System.Windows.Forms.LinkLabel exitProgramLabel;
		private System.Windows.Forms.TextBox insertItemBox;
		private System.Windows.Forms.Panel footerPanel;
		private System.Windows.Forms.Label rebuildLabel;
		private System.Windows.Forms.ListBox rebuildList;
		private System.Windows.Forms.LinkLabel insertItemLabel;
		private System.Windows.Forms.Panel rebuildPanel;
		private System.Windows.Forms.Panel drawPanel;
		private System.Windows.Forms.LinkLabel flushTreeLabel;
		private System.Windows.Forms.ErrorProvider myErrorProvider;
		private System.Windows.Forms.PictureBox pictureBox1;
		
		private System.ComponentModel.Container components = null;

		private Tree mySearchTree;
		private TreeDrawer myTreeDrawer;
		private System.Drawing.Graphics myGraphics;


		public SearchTree()
		{
			InitializeComponent();
			mySearchTree = new Tree();
			myTreeDrawer = new TreeDrawer();
			myGraphics = this.drawPanel.CreateGraphics();
			myGraphics.SetClip(new System.Drawing.Rectangle(0, 0, drawPanel.Width, drawPanel.Height));
		}

		
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(SearchTree));
			this.headerPanel = new System.Windows.Forms.Panel();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.titleLabel = new System.Windows.Forms.Label();
			this.controlPanel = new System.Windows.Forms.Panel();
			this.flushTreeLabel = new System.Windows.Forms.LinkLabel();
			this.insertItemBox = new System.Windows.Forms.TextBox();
			this.insertItemLabel = new System.Windows.Forms.LinkLabel();
			this.exitProgramLabel = new System.Windows.Forms.LinkLabel();
			this.footerPanel = new System.Windows.Forms.Panel();
			this.rebuildPanel = new System.Windows.Forms.Panel();
			this.rebuildList = new System.Windows.Forms.ListBox();
			this.rebuildLabel = new System.Windows.Forms.Label();
			this.drawPanel = new System.Windows.Forms.Panel();
			this.myErrorProvider = new System.Windows.Forms.ErrorProvider();
			this.headerPanel.SuspendLayout();
			this.controlPanel.SuspendLayout();
			this.rebuildPanel.SuspendLayout();
			this.SuspendLayout();
			// 
			// headerPanel
			// 
			this.headerPanel.BackColor = System.Drawing.Color.Navy;
			this.headerPanel.Controls.Add(this.pictureBox1);
			this.headerPanel.Controls.Add(this.titleLabel);
			this.headerPanel.Location = new System.Drawing.Point(0, 0);
			this.headerPanel.Name = "headerPanel";
			this.headerPanel.Size = new System.Drawing.Size(792, 96);
			this.headerPanel.TabIndex = 0;
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.Navy;
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(392, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(300, 90);
			this.pictureBox1.TabIndex = 1;
			this.pictureBox1.TabStop = false;
			// 
			// titleLabel
			// 
			this.titleLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 14F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.titleLabel.ForeColor = System.Drawing.Color.White;
			this.titleLabel.Location = new System.Drawing.Point(24, 32);
			this.titleLabel.Name = "titleLabel";
			this.titleLabel.Size = new System.Drawing.Size(192, 24);
			this.titleLabel.TabIndex = 0;
			this.titleLabel.Text = "SearchTree Example";
			// 
			// controlPanel
			// 
			this.controlPanel.BackColor = System.Drawing.Color.Gainsboro;
			this.controlPanel.Controls.Add(this.flushTreeLabel);
			this.controlPanel.Controls.Add(this.insertItemBox);
			this.controlPanel.Controls.Add(this.insertItemLabel);
			this.controlPanel.Controls.Add(this.exitProgramLabel);
			this.controlPanel.Location = new System.Drawing.Point(0, 96);
			this.controlPanel.Name = "controlPanel";
			this.controlPanel.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.controlPanel.Size = new System.Drawing.Size(128, 416);
			this.controlPanel.TabIndex = 2;
			// 
			// flushTreeLabel
			// 
			this.flushTreeLabel.ActiveLinkColor = System.Drawing.Color.DarkGray;
			this.flushTreeLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.flushTreeLabel.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.flushTreeLabel.LinkColor = System.Drawing.Color.Black;
			this.flushTreeLabel.Location = new System.Drawing.Point(22, 88);
			this.flushTreeLabel.Name = "flushTreeLabel";
			this.flushTreeLabel.Size = new System.Drawing.Size(72, 16);
			this.flushTreeLabel.TabIndex = 3;
			this.flushTreeLabel.TabStop = true;
			this.flushTreeLabel.Text = "Flush tree";
			this.flushTreeLabel.VisitedLinkColor = System.Drawing.Color.Black;
			this.flushTreeLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.flushTreeLabel_LinkClicked);
			this.flushTreeLabel.Enabled = false;
			// 
			// insertItemBox
			// 
			this.insertItemBox.Location = new System.Drawing.Point(24, 38);
			this.insertItemBox.MaxLength = 10;
			this.insertItemBox.Name = "insertItemBox";
			this.insertItemBox.Size = new System.Drawing.Size(72, 20);
			this.insertItemBox.TabIndex = 1;
			this.insertItemBox.Text = "";
			this.insertItemBox.TextChanged += new System.EventHandler(this.insertItemBox_TextChanged);
			this.insertItemBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.insertItemBox_KeyUp);
			// 
			// insertItemLabel
			// 
			this.insertItemLabel.ActiveLinkColor = System.Drawing.Color.DarkGray;
			this.insertItemLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.insertItemLabel.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.insertItemLabel.LinkColor = System.Drawing.Color.Black;
			this.insertItemLabel.Location = new System.Drawing.Point(22, 64);
			this.insertItemLabel.Name = "insertItemLabel";
			this.insertItemLabel.Size = new System.Drawing.Size(72, 16);
			this.insertItemLabel.TabIndex = 2;
			this.insertItemLabel.TabStop = true;
			this.insertItemLabel.Text = "Insert item";
			this.insertItemLabel.VisitedLinkColor = System.Drawing.Color.Black;
			this.insertItemLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.insertItemLabel_LinkClicked);
			this.insertItemLabel.Enabled = false;
			// 
			// exitProgramLabel
			// 
			this.exitProgramLabel.ActiveLinkColor = System.Drawing.Color.DarkGray;
			this.exitProgramLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.exitProgramLabel.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline;
			this.exitProgramLabel.LinkColor = System.Drawing.Color.Black;
			this.exitProgramLabel.Location = new System.Drawing.Point(22, 112);
			this.exitProgramLabel.Name = "exitProgramLabel";
			this.exitProgramLabel.Size = new System.Drawing.Size(88, 16);
			this.exitProgramLabel.TabIndex = 4;
			this.exitProgramLabel.TabStop = true;
			this.exitProgramLabel.Text = "Exit program";
			this.exitProgramLabel.VisitedLinkColor = System.Drawing.Color.Black;
			this.exitProgramLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.exitProgramLabel_LinkClicked);
			// 
			// footerPanel
			// 
			this.footerPanel.BackColor = System.Drawing.Color.Navy;
			this.footerPanel.Location = new System.Drawing.Point(0, 512);
			this.footerPanel.Name = "footerPanel";
			this.footerPanel.Size = new System.Drawing.Size(800, 50);
			this.footerPanel.TabIndex = 3;
			// 
			// rebuildPanel
			// 
			this.rebuildPanel.BackColor = System.Drawing.Color.Gainsboro;
			this.rebuildPanel.Controls.Add(this.rebuildList);
			this.rebuildPanel.Controls.Add(this.rebuildLabel);
			this.rebuildPanel.Location = new System.Drawing.Point(632, 96);
			this.rebuildPanel.Name = "rebuildPanel";
			this.rebuildPanel.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.rebuildPanel.Size = new System.Drawing.Size(160, 416);
			this.rebuildPanel.TabIndex = 4;
			// 
			// rebuildList
			// 
			this.rebuildList.Location = new System.Drawing.Point(16, 64);
			this.rebuildList.Name = "rebuildList";
			this.rebuildList.Size = new System.Drawing.Size(128, 251);
			this.rebuildList.TabIndex = 0;
			// 
			// rebuildLabel
			// 
			this.rebuildLabel.BackColor = System.Drawing.Color.Transparent;
			this.rebuildLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.rebuildLabel.ForeColor = System.Drawing.Color.Black;
			this.rebuildLabel.Location = new System.Drawing.Point(8, 16);
			this.rebuildLabel.Name = "rebuildLabel";
			this.rebuildLabel.Size = new System.Drawing.Size(144, 40);
			this.rebuildLabel.TabIndex = 0;
			this.rebuildLabel.Text = "Rebuild was needed after inserting number:";
			this.rebuildLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// drawPanel
			// 
			this.drawPanel.AutoScroll = true;
			this.drawPanel.Location = new System.Drawing.Point(128, 96);
			this.drawPanel.Name = "drawPanel";
			this.drawPanel.Size = new System.Drawing.Size(504, 416);
			this.drawPanel.TabIndex = 0;
			this.drawPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.drawPanel_Paint);
			// 
			// myErrorProvider
			// 
			this.myErrorProvider.ContainerControl = this;
			// 
			// SearchTree
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(792, 558);
			this.Controls.Add(this.footerPanel);
			this.Controls.Add(this.rebuildPanel);
			this.Controls.Add(this.drawPanel);
			this.Controls.Add(this.controlPanel);
			this.Controls.Add(this.headerPanel);
			this.MaximumSize = new System.Drawing.Size(800, 592);
			this.MinimumSize = new System.Drawing.Size(800, 592);
			this.Name = "SearchTree";
			this.Text = "SearchTree - Kroly Pfaff";
			this.headerPanel.ResumeLayout(false);
			this.controlPanel.ResumeLayout(false);
			this.rebuildPanel.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		
		[STAThread]
		static void Main() 
		{
			Application.Run(new SearchTree());
		}

		private void InsertItem()
		{
			try
			{
				mySearchTree.Insert(System.Convert.ToInt32(this.insertItemBox.Text));
				int newBuildIndex = mySearchTree.MustRebuild();
				if ( newBuildIndex != -1 )
				{
					TreeRebuilder myTreeRebuilder = new TreeRebuilder(ref mySearchTree);
					myTreeRebuilder.Rebuild();
					rebuildList.Items.Add("no. " + newBuildIndex + ",\t insert: " + System.Convert.ToInt32(this.insertItemBox.Text));
				}
				this.insertItemBox.Text = "";
				this.flushTreeLabel.Enabled = true;
				this.myErrorProvider.SetError(this.insertItemBox, "");
				myGraphics.Clear(drawPanel.BackColor);
				myTreeDrawer.Draw(myGraphics, mySearchTree);
			}
			catch
			{
				this.myErrorProvider.SetError(this.insertItemBox, "Something has gone wrong... please change your computer...");
			}
		}

		private void insertItemLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			InsertItem();
		}

		private void exitProgramLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			this.Dispose(true);
		}

		private void flushTreeLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			this.flushTreeLabel.Enabled = false;
			mySearchTree.Empty();
			this.rebuildList.Items.Clear();
			myGraphics.Clear(drawPanel.BackColor);
		}

		private void insertItemBox_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ((e.KeyCode == Keys.Enter) && (this.insertItemBox.Text!=""))
			{
				InsertItem();
			}

		}

		private void drawPanel_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if (mySearchTree.GetCount() != 0)
			{
				myTreeDrawer.Draw(myGraphics, mySearchTree);
			}
		}

		private void insertItemBox_TextChanged(object sender, System.EventArgs e)
		{
			if (insertItemBox.Text!="")
			{
				insertItemLabel.Enabled = true;
			}
			else
			{
				insertItemLabel.Enabled = false;
			}
		}
	}
}
